// DLL_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DLL_Test.h"
#include "DLL_TestDlg.h"
#include "ST_hdcos.h"
#include "Mwic_32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLL_TestDlg dialog

CDLL_TestDlg::CDLL_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDLL_TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDLL_TestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDLL_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDLL_TestDlg)
	DDX_Control(pDX, IDC_ATR_DATA, m_ATRButton);
	DDX_Control(pDX, IDC_SENDCOMMAND, m_SendButton);
	DDX_Control(pDX, IDC_RESET, m_ResetButton);
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Control(pDX, IDC_DATA, m_DataEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDLL_TestDlg, CDialog)
	//{{AFX_MSG_MAP(CDLL_TestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_LBN_SELCHANGE(IDC_LIST, OnSelchangeList)
	ON_BN_CLICKED(IDC_ATR_DATA, OnAtrData)
	ON_BN_CLICKED(IDC_SENDCOMMAND, OnSendcommand)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CDLL_TestDlg message handlers

BOOL CDLL_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here                           
//	EnableWindows(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

/*void CDLL_TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
*/
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDLL_TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR CDLL_TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDLL_TestDlg::OnOpen() 
{
	DevHandle = (HANDLE)IFD_Open(USB1);
	if (DevHandle == (HANDLE)1) {
		m_List.AddString("Can not open a reader device.");
		CDLL_TestDlg::EnableWindows(FALSE);
		m_ATRButton.EnableWindow(FALSE);
		m_ResetButton.EnableWindow(FALSE);
		m_SendButton.EnableWindow(FALSE);
		return;
	}
	m_List.AddString("Reader device is opened correctly.");
	GetDlgItem(IDC_OPEN)->EnableWindow(FALSE);
	CDLL_TestDlg::EnableWindows(TRUE);
	m_ATRButton.EnableWindow(TRUE);
	m_ResetButton.EnableWindow(TRUE);
	m_SendButton.EnableWindow(TRUE);
}

void CDLL_TestDlg::EnableWindows(BOOL State)
{
	GetDlgItem(IDC_CLA)->EnableWindow(State);
	GetDlgItem(IDC_INS)->EnableWindow(State);
	GetDlgItem(IDC_P1)->EnableWindow(State);
	GetDlgItem(IDC_P2)->EnableWindow(State);
	GetDlgItem(IDC_LC)->EnableWindow(State);
	GetDlgItem(IDC_LE)->EnableWindow(State);
	GetDlgItem(IDC_DATA)->EnableWindow(State);
}

void CDLL_TestDlg::ShowReport(LPTSTR msg, UINT len)
{
	m_List.AddString(msg);
	ShowReport(len);
}

void CDLL_TestDlg::ShowReport(UINT uLength)
{
	UINT	index;
	CString	line0, line;

	for (index = 0; index < uLength; index++) {
		if ((index % 16) == 0) {
			if (index) {
				m_List.AddString(line0);
				line0.Empty();
			}
			line0.Format("  -> %02X", InOutBuffer[index]);
		}
		else {
			line.Format(" %02X", InOutBuffer[index]);
			line0 += line;
		}
	}
	if (index)
		m_List.AddString(line0);

	m_List.SetCurSel(m_List.GetCount() - 1);
}

UINT CDLL_TestDlg::FormReport(LPTSTR string)
{
	UINT	index = 0;
	LPTSTR	token;
	BYTE	chr0, chr;

	token = strtok(string, " \t");
	while (token) {
		chr0 = 0;
		while (chr = *token++)
			if (isxdigit(chr)) {
				if (isdigit(chr))
					chr0 = chr0 * 16 + chr - '0';
				else
					chr0 = chr0 * 16 + toupper(chr) - 'A' + 10;
			}
			else
				return 0;

		InOutBuffer[index] = chr0;
		index++;

		token = strtok(NULL, " \t");
	}

	return index;
}

UINT CDLL_TestDlg::GetCLA()
{
	UINT	CLA;
	CLA = GetByte(IDC_CLA);
	if (CLA == -1 || CLA > 255) {
		m_List.AddString("Please enter CLA in hex format of range (00~FF)");
		GetDlgItem(IDC_CLA)->SetFocus();
	}
	else {
		CString str;
		str.Format("<CLA=%02X>", CLA);
		m_List.AddString(str);
	}
	return CLA;
}

UINT CDLL_TestDlg::GetINS()
{
	UINT	INS;
	INS = GetByte(IDC_INS);
	if (INS == -1 || INS > 255) {
		m_List.AddString("Please enter INS in hex format of range (00~FF)");
		GetDlgItem(IDC_INS)->SetFocus();
	}
	else {
		CString str;
		str.Format("<INS=%02X>", INS);
		m_List.AddString(str);
	}
	return INS;
}

UINT CDLL_TestDlg::GetP1()
{
	UINT	P1;
	P1 = GetByte(IDC_P1);
	if (P1 == -1 || P1 > 255) {
		m_List.AddString("Please enter P1 in hex format of range (00~FF)");
		GetDlgItem(IDC_P1)->SetFocus();
	}
	else {
		CString str;
		str.Format("<P1=%02X>", P1);
		m_List.AddString(str);
	}
	return P1;
}

UINT CDLL_TestDlg::GetP2()
{
	UINT	P2;
	P2 = GetByte(IDC_P2);
	if (P2 == -1 || P2 > 255) {
		m_List.AddString("Please enter P2 in hex format of range (00~FF)");
		GetDlgItem(IDC_P2)->SetFocus();
	}
	else {
		CString str;
		str.Format("<P2=%02X>", P2);
		m_List.AddString(str);
	}
	return P2;
}

UINT CDLL_TestDlg::GetLC()
{
	UINT	LC;
	LC = GetByte(IDC_LC);
	if (LC == -1 || LC > 255) {
		m_List.AddString("Please enter LC in hex format of range (00~FF)");
		GetDlgItem(IDC_LC)->SetFocus();
	}
	else {
		CString str;
		str.Format("<LC=%02X>", LC);
		m_List.AddString(str);
	}
	return LC;
}

UINT CDLL_TestDlg::GetLE()
{
	UINT	LE;
	LE = GetByte(IDC_LE);
	if (LE == -1 || LE > 128) {
		m_List.AddString("Please enter LE in hex format of range (00~FF)");
		GetDlgItem(IDC_LE)->SetFocus();
		return -1;
	}

	CString str;
	str.Format("<LE=%02X>", LE);
	m_List.AddString(str);
	return LE;
}

UINT CDLL_TestDlg::GetData(UINT expect)
{
	CString str;
	UINT	len;

	len = GetDlgItemText(IDC_DATA, str);
	if (len == 0)
		goto Data_Error;
	len = FormReport(str.GetBuffer(1));
	if (len != expect) {
Data_Error:
		m_List.AddString("Data length error. Please enter Data in hex format and delimit with space");
		GetDlgItem(IDC_DATA)->SetFocus();
		return 0;
	}

	len = min(len, expect);
	str.Format("Sending %d bytes Data ...", len);
	ShowReport(str.GetBuffer(1), len);
	return len;
}

UINT CDLL_TestDlg::GetByte(UINT item)
{
	CString str;
	UINT	len;

	len = GetDlgItemText(item, str);
	if (len == 0)
		return -1;
	len = FormReport(str.GetBuffer(1));
	if (len == 0)
		return -1;
	
	return InOutBuffer[0];
}

void CDLL_TestDlg::ShowLine(LPTSTR msg)
{
	m_List.AddString(msg);
	m_List.SetCurSel(m_List.GetCount() - 1);
}

void CDLL_TestDlg::ShowError(void)
{
	CString	str;
	DWORD	dwError = GetLastError();
	str.Format("ErrorCode=%d",dwError);
	m_List.AddString(str);
	return;
}

void CDLL_TestDlg::ShowLeData(UINT len)
{
 	CString	str;
	str.Format("LeData is:");
	memcpy(InOutBuffer, LeData, len);
	ShowReport(len);
}

BOOL CDLL_TestDlg::ShowResponseMsg(LPSTR sw)
{
	UINT	ResMsg = MAKEWORD(sw[0], sw[1]);
	CString str;	

	str.Format("Response is: (0x%04X)", ResMsg);
	m_List.AddString(str);
	return TRUE;
}

void CDLL_TestDlg::OnReset() 
{
	char	ATR_Data[20];

	state = IC_RESET(DevHandle, ATR_Data);
	if (state == 1) {
		CString	str;
		DWORD	dwError = GetLastError();
		str.Format("Error on execute IC_RESET(), ErrorCode=%d", dwError);
		m_List.AddString(str);
		return;
	}

	m_List.AddString("IC_RESET() is executed successfully");
	memcpy(InOutBuffer, ATR_Data, 20);
	ShowReport(20);
}

void CDLL_TestDlg::OnSelchangeList() 
{
	// TODO: Add your control notification handler code here
}

void CDLL_TestDlg::OnAtrData() 
{
	char	ATR_Data[20];

	state = IC_GetATR(DevHandle, ATR_Data);
	if (state == 1) {
		CString	str;
		DWORD	dwError = GetLastError();
		str.Format("Error on execute IC_RESET(), ErrorCode=%d", dwError);
		m_List.AddString(str);
		return;
	}

	m_List.AddString("IC_GetATR() is executed successfully");
	memcpy(InOutBuffer, ATR_Data, 20);
	ShowReport(20);
}


void CDLL_TestDlg::OnSendcommand() 
{
	CLA = GetCLA();
	if (CLA == -1) {
		return;
	}
	
	INS = GetINS();
	if (INS == -1) {
		return;
	}

	P1 = GetP1();
	if (P1 == -1) {
		return;
	}
	P2 = GetP2();
	if (P2 == -1) {
		return;
	}
	LC = GetLC();
	if (LC == -1) {
		m_List.AddString("If no LC needed please enter 0");
		return;
	}

	LE = GetLE();
	if (LE == -1) {
		m_List.AddString("If no LE needed please enter 0.");
		return;
	}

	if (LC != 0) {
		UINT len = GetData(LC);
		if (len != LC) {
			return;
		}
	}

	state = SendCommand(DevHandle, INS, CLA, P1, P2, LE, LC, (LPSTR)InOutBuffer, LeData, SW);
	if (state == 0xff)
		ShowError();
	else {
		ShowResponseMsg(SW); 
		ShowLeData(state);
	}
}
