// DLL_TestDlg.h : header file
//

#if !defined(AFX_DLL_TESTDLG_H__778D3083_5B3A_44F4_A7DF_E80ABD1B976C__INCLUDED_)
#define AFX_DLL_TESTDLG_H__778D3083_5B3A_44F4_A7DF_E80ABD1B976C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDLL_TestDlg dialog

class CDLL_TestDlg : public CDialog
{
// Construction
public:
	CDLL_TestDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDLL_TestDlg)
	enum { IDD = IDD_DLL_TEST_DIALOG };
	CButton	m_ATRButton;
	CButton	m_SendButton;
	CButton	m_ResetButton;
	CListBox	m_List;
	CComboBox	m_Command;
	CEdit	m_DataEdit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDLL_TestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDLL_TestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTest();
	afx_msg void OnOpen();
	afx_msg void OnSelectCommand();
	afx_msg void OnReset();
	afx_msg void OnSelchangeList();
	afx_msg void OnAtrData();
	afx_msg void OnSenddata();
	afx_msg void OnSendcommand();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int		state;
	HANDLE	DevHandle;

	UINT	CurFunc;
	char	CLA, INS, P1, P2, LC, LE;
	char	LeData[128];
	char	SW[2];

	unsigned char InOutBuffer[100];

	void EnableWindows(BOOL State);
	void ShowLine(LPTSTR msg);
	UINT FormReport(LPTSTR string);
	void ShowReport(UINT uLength);
	void ShowReport(LPTSTR msg, UINT len);
	void ShowError(void);
	void ShowLeData(UINT len);
	BOOL ShowResponseMsg(LPSTR sw);

	UINT GetByte(UINT item);
	UINT GetData(UINT expect);
	UINT GetCLA();
	UINT GetINS();
	UINT GetP1();
	UINT GetP2();
	UINT GetLC();
	UINT GetLE();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLL_TESTDLG_H__778D3083_5B3A_44F4_A7DF_E80ABD1B976C__INCLUDED_)
