/**************** (c) 2000  STMicroelectronics **********************

PROJECT : USB - ST7 FULL SPEED

VERSION :  v 0.96

CREATION DATE :  01/12/2000

AUTHOR : MICROCONTROLLER DIVISION / ST Rousset

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

MODIFICATIONS : 

******************************************************************************/

extern void USER_USB_Reset(void);
extern void USER_USB_Status_In(void);
extern void USER_USB_Status_Out(void);
extern void USER_USB_SOF(void);
extern void USER_USB_Suspend(void);
extern void USER_USB_ESuspend(void);
extern void USER_USB_WakeUp(void);

extern char USER_USB_Setup(void);

extern char USER_USB_Set_Configuration(void);     
extern char USER_USB_Set_Interface(void);

extern void USER_USB_Clear_Feature_Int(void);
extern void USER_USB_Set_Feature_Int(void);

extern void USER_USB_Clear_Feature_EP(void);
extern void USER_USB_Set_Feature_EP(void);

extern void USER_USB_CopyData(unsigned char Length);

#define SET_REPORT 0x09
#define GET_REPORT 0x01
#define OUTPUT_REPORT 0x02
#define FEATURE_REPORT 0x03
#define INPUT_REPORT	0x01


/**************** (c) 2000  STMicroelectronics **********************/