/**************** (c) 2000  STMicroelectronics **********************

PROJECT : USB - ST7 FULL SPEED

VERSION :  v 0.96

CREATION DATE :  01/12/2000

AUTHOR : MICROCONTROLLER DIVISION / ST Rousset

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

MODIFICATIONS : 

******************************************************************************/

#ifndef APPLI_H
#define APPLI_H

extern void USER_init(void);
extern void Init_port(void);
extern void USER_Application(void);
void My_Suspend(void);
void My_EndSuspend(void);

#define MAX_NUM_CONFIG		1
#define MAX_NUM_INTERFACE	2
#define INT_MASK		(IMR_CTR | IMR_SOVR | IMR_RESET | IMR_ERR | IMR_SUSP | IMR_ESUSP)

////////////////////////////////////////////////////////////////////
#pragma DATA_SEG DEFAULT_RAM
extern unsigned char Max_Lun;
extern unsigned char LUN_Config;

#endif
/**************** (c) 2000  STMicroelectronics **********************/
