/**************** (c) 2000  STMicroelectronics **********************

PROJECT : USB - ST7 FULL SPEED

VERSION :  v 0.96

CREATION DATE :  01/12/2000

AUTHOR : MICROCONTROLLER DIVISION / ST Rousset

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

MODIFICATIONS : 

******************************************************************************/


#ifndef DESCRIPT_H
#define DESCRIPT_H                       

/**********************************************************************************/
/*						DESCRIPTORS FOR THE DEFAULT PRODUCT						  */	
/**********************************************************************************/

#define SIZE_DEVICE_DESC 18
//#define SIZE_CONFIG_DESC 32   // 1 interface => 32, 2 Int => 55
#define SIZE_CONFIG_DESC 50   //   32 + 9 + 9
#define SIZE_STRING_DESCRIPTOR 4
#define SIZE_STRING_VENDOR 38
#define SIZE_STRING_PRODUCT 48
#define SIZE_STRING_SERIAL 66
#define SIZE_STRING_INTERFACE 20

#define NUM_STRING_DESC		5
/************************* Prototypes declaration section ******************************/

#pragma CONST_SEG USER_CONST
extern const char Appli_DeviceDescriptor0[];
extern const char Appli_DeviceDescriptor1[];
extern const char Appli_ConfigDescriptor[];
extern const char Appli_StringDescriptor[];
extern const char Appli_StringVendor[];
extern const char Appli_StringProduct[];
extern const char Appli_StringSerial[];
extern const char Appli_StringInterface[];

#endif

/**************** (c) 2000  STMicroelectronics **********************/



